moodycamel Namespace Reference

## Namespaces

namespace | spsc_sema

## Classes

class | BlockingReaderWriterQueue
class | ReaderWriterQueue
class | weak_atomic

## Enumerations

enum | memory_order { memory_order_relaxed , memory_order_acquire , memory_order_release , memory_order_acq_rel , memory_order_seq_cst , memory_order_sync = memory_order_seq_cst }

## Functions

AE_FORCEINLINE void | compiler_fence (memory_order order)
AE_FORCEINLINE void | fence (memory_order order)

## Enumeration Type Documentation

## memory_order

enum moodycamel::memory_order

Enumerator
memory_order_relaxed |
memory_order_acquire |
memory_order_release |
memory_order_acq_rel |
memory_order_seq_cst |
memory_order_sync |

## Function Documentation

## compiler_fence()

AE_FORCEINLINE void moodycamel::compiler_fence | ( | memory_order | order | ) |

References memory_order_acq_rel, memory_order_acquire, memory_order_relaxed, memory_order_release, and memory_order_seq_cst.

Referenced by moodycamel::ReaderWriterQueue< T, MAX_BLOCK_SIZE >::pop(), and moodycamel::ReaderWriterQueue< T, MAX_BLOCK_SIZE >::try_dequeue().

## fence()

AE_FORCEINLINE void moodycamel::fence | ( | memory_order | order | ) |

References memory_order_acq_rel, memory_order_acquire, memory_order_relaxed, memory_order_release, and memory_order_seq_cst.

Referenced by moodycamel::ReaderWriterQueue< T, MAX_BLOCK_SIZE >::peek(), moodycamel::ReaderWriterQueue< T, MAX_BLOCK_SIZE >::pop(), moodycamel::ReaderWriterQueue< T, MAX_BLOCK_SIZE >::ReaderWriterQueue(), moodycamel::ReaderWriterQueue< T, MAX_BLOCK_SIZE >::size_approx(), moodycamel::ReaderWriterQueue< T, MAX_BLOCK_SIZE >::try_dequeue(), and moodycamel::ReaderWriterQueue< T, MAX_BLOCK_SIZE >::~ReaderWriterQueue().